<template>
  <div class="form-wrapper">
    <form
      novalidate
      autocomplete="off"
      class="px-8 py-10 bg-gray-100 text-brown-700 shadow sm:px-20 sm:py-16"
      @submit.prevent="submit"
    >
      <slot :update-field="updateField" :errors="_errors" />
    </form>
  </div>
</template>

<script>
import { Machine, interpret, assign } from 'xstate';
import Validator from 'validatorjs';

Validator.useLang('es');

const formMachine = Machine(
  {
    id: 'submit',
    context: {
      isValid: false,
      errors: {},
    },
    initial: 'clean',
    states: {
      clean: {
        on: {
          VALIDATE: { target: 'checking' },
        },
      },
      checking: {
        entry: 'validateForm',
        on: {
          '': [{ target: 'valid', cond: 'isFormValid' }, { target: 'invalid' }],
        },
      },
      valid: {
        on: { CLEAN: 'clean' },
      },
      invalid: {
        on: {
          VALIDATE: { target: 'checking' },
        },
      },
    },
  },
  {
    actions: {
      validateForm: assign((ctx, event) => {
        const validation = new Validator(event.data, event.rules);
        const isValid = validation.passes();
        const errors = validation.errors.all();

        return {
          isValid,
          errors,
        };
      }),
    },
    guards: {
      isFormValid: ctx => ctx.isValid,
    },
  }
);

export default {
  name: 'AForm',
  props: {
    // eslint-disable-next-line no-unused-vars
    send: { type: Function, default: _ => null },
    submission: { type: String, default: 'idle' },
    fields: { type: Object, default: () => ({}) },
  },
  data: () => ({
    form: {},
    formService: interpret(formMachine),
    status: formMachine.initialState.value,
    errors: formMachine.initialState.context.errors,
  }),
  computed: {
    validations() {
      return Object.keys(this.fields).reduce(
        (rules, field) => ({
          ...rules,
          [field]: this.fields[field].validation,
        }),
        {}
      );
    },
    _errors() {
      return {
        has: field => !!this.errors[field],
        first: field => this.errors[field][0],
        remove: field => {
          // eslint-disable-next-line no-unused-vars
          const { [field]: _, ...errors } = this.errors;
          // eslint-disable-next-line vue/no-side-effects-in-computed-properties
          this.errors = errors;
        },
      };
    },
  },
  watch: {
    status(formStatus) {
      if (formStatus === 'valid') {
        const data = this.normalizeData();
        this.send(data);
      }
    },
    submission(submissionStatus) {
      if (submissionStatus === 'success') {
        this.reset();
      }
      if (submissionStatus === 'idle') {
        this.formService.send('CLEAN');
      }
    },
  },
  created() {
    this.formService
      .onTransition(state => {
        this.status = state.value;
        this.errors = state.context.errors;
      })
      .start();
  },
  methods: {
    updateField({ field, value }) {
      this.form[field] = value;
      this._errors.remove(field);
    },
    submit() {
      this.formService.send('VALIDATE', {
        data: this.form,
        rules: this.validations,
      });
    },
    reset() {
      this.form = {};
      Object.keys(this.fields).forEach(field => this.fields[field].reset());
    },
    normalizeData() {
      return Object.keys(this.fields).reduce(
        (data, field) => ({
          ...data,
          [this.fields[field].fid]: this.form[field],
        }),
        {}
      );
    },
  },
};
</script>

<style lang="postcss" scoped>
.form-wrapper {
  display: grid;
  grid-template-columns:
    minmax(0, 1fr)
    minmax(auto, theme('spacing.200'))
    minmax(0, 1fr);

  & form {
    grid-column: 2;
  }
}
</style>
